## mapnik 2.0.0+ds1

=== SConstruct ===
# This file is part of Mapnik (c++ mapping toolkit)
#
# Copyright (C) 2009 Artem Pavlenko, Jean-Francois Doyon, Dane Springmeyer
#
# Mapnik is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# $Id: SConstruct 3352 2011-09-15 22:15:04Z dane $


import os
import sys
import re
import platform
from glob import glob
from subprocess import Popen, PIPE
from SCons.SConf import SetCacheMode
import pickle

try:
    import distutils.sysconfig
    HAS_DISTUTILS = True
except:
    HAS_DISTUTILS = False


# local file to hold custom user configuration variables
# Todo check timestamp, reload if changed?
SCONS_LOCAL_CONFIG = 'config.py'
# build log
SCONS_LOCAL_LOG = 'config.log'
# local pickled file to cache configured environment
SCONS_CONFIGURE_CACHE = 'config.cache'
# directory SCons uses to stash build tests
SCONF_TEMP_DIR = '.sconf_temp'
# auto-search directories for boost libs/headers
BOOST_SEARCH_PREFIXES = ['/usr/local','/opt/local','/sw','/usr',]
BOOST_MIN_VERSION = '1.41'
CAIROMM_MIN_VERSION = '1.8.0'

DEFAULT_LINK_PRIORITY = ['internal','other','frameworks','user','system']


pretty_dep_names = {
    'ociei':'Oracle database library | configure with OCCI_LIBS & OCCI_INCLUDES | more info: http://trac.mapnik.org/wiki/OCCI',
    'gdal':'GDAL C++ library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: http://trac.mapnik.org/wiki/GDAL',
    'ogr':'OGR-enabled GDAL C++ Library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: http://trac.mapnik.org/wiki/OGR',
    'geos_c':'GEOS Simple Geometry Specification C Library | configured with GEOS_LIB & GEOS_INCLUDE | more info: http://trac.mapnik.org/wiki/GEOS',
    'cairo':'Cairo C library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'cairomm':'Cairomm C++ bindings to Cairo library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'cairomm-version':'Cairomm version is too old (so cairo renderer will not be built), you need at least %s' % CAIROMM_MIN_VERSION,
    'pycairo':'Python bindings to Cairo library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'proj':'Proj.4 C Projections library | configure with PROJ_LIBS & PROJ_INCLUDES | more info: http://trac.osgeo.org/proj/',
    'pg':'Postgres C Library requiered for PostGIS plugin | configure with pg_config program | more info: http://trac.mapnik.org/wiki/PostGIS',
    'sqlite3':'SQLite3 C Library | configure with SQLITE_LIBS & SQLITE_INCLUDES | more info: http://trac.mapnik.org/wiki/SQLite',
    'jpeg':'JPEG C library | configure with JPEG_LIBS & JPEG_INCLUDES',
    'tiff':'TIFF C library | configure with TIFF_LIBS & TIFF_INCLUDES',
    'png':'PNG C library | configure with PNG_LIBS & PNG_INCLUDES',
    'icuuc':'ICU C++ library | configure with ICU_LIBS & ICU_INCLUDES or use ICU_LIB_NAME to specify custom lib name  | more info: http://site.icu-project.org/',
    'ltdl':'GNU Libtool | more info: http://www.gnu.org/software/libtool',
    'z':'Z compression library | more info: http://www.zlib.net/',
    'm':'Basic math library, part of C++ stlib',
    'pkg-config':'pkg-config tool | more info: http://pkg-config.freedesktop.org',
    'pg_config':'pg_config program | try setting PG_CONFIG SCons option',
    'xml2-config':'xml2-config program | try setting XML2_CONFIG SCons option',
    'gdal-config':'gdal-config program | try setting GDAL_CONFIG SCons option',
    'geos-config':'geos-config program | try setting GEOS_CONFIG SCons option',
    'freetype-config':'freetype-config program | try setting FREETYPE_CONFIG SCons option',
    'osm':'more info: http://trac.mapnik.org/wiki/OsmPlugin',
    'curl':'libcurl is required for the "osm" plugin - more info: http://trac.mapnik.org/wiki/OsmPlugin',
    'boost_regex_icu':'libboost_regex built with optional ICU unicode support is needed for unicode regex support in mapnik.',
    'sqlite_rtree':'The SQLite plugin requires libsqlite3 built with RTREE support (-DSQLITE_ENABLE_RTREE=1)',
    'pgsql2sqlite_rtree':'The pgsql2sqlite program requires libsqlite3 built with RTREE support (-DSQLITE_ENABLE_RTREE=1)'
    }
    
# Core plugin build configuration
# opts.AddVariables still hardcoded however...
PLUGINS = { # plugins with external dependencies
            # configured by calling project, henche 'path':None
            'postgis': {'default':True,'path':None,'inc':'libpq-fe.h','lib':'pq','lang':'C'},
            'gdal':    {'default':True,'path':None,'inc':'gdal_priv.h','lib':'gdal','lang':'C++'},
            'ogr':     {'default':True,'path':None,'inc':'ogrsf_frmts.h','lib':'gdal','lang':'C++'},
            'geos':    {'default':False,'path':None,'inc':'geos_c.h','lib':'geos_c','lang':'C'},
            # configured with custom paths, hence 'path': PREFIX/INCLUDES/LIBS
            'occi':    {'default':False,'path':'OCCI','inc':'occi.h','lib':'ociei','lang':'C++'},
            'sqlite':  {'default':True,'path':'SQLITE','inc':'sqlite3.h','lib':'sqlite3','lang':'C'},
            'rasterlite':  {'default':False,'path':'RASTERLITE','inc':['sqlite3.h','rasterlite.h'],'lib':'rasterlite','lang':'C'},
            
            # todo: osm plugin does also depend on libxml2 (but there is a separate check for that)
            'osm':     {'default':False,'path':None,'inc':'curl/curl.h','lib':'curl','lang':'C'},

            # plugins without external dependencies requiring CheckLibWithHeader...
            'shape':   {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'raster':  {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'kismet':  {'default':False,'path':None,'inc':None,'lib':None,'lang':'C++'},
            }


#### SCons build options and initial setup ####
env = Environment(ENV=os.environ)

def color_print(color,text,newline=True):
    # 1 - red
    # 2 - green
    # 3 - yellow
    # 4 - blue
    text = "\033[9%sm%s\033[0m" % (color,text)
    if not newline:
        print text,
    else:
        print text

def regular_print(color,text,newline=True):
    if not newline:
        print text,
    else:
        print text

def call(cmd, silent=False):
    stdin, stderr = Popen(cmd, shell=True, stdout=PIPE, stderr=PIPE).communicate()
    if not stderr:
        return stdin.strip()
    elif not silent:
        color_print(1,'Problem encounted with SCons scripts, please post bug report to: http://trac.mapnik.org\nError was: %s' % stderr)

def strip_first(string,find,replace=''):
    if string.startswith(find):
        return string.replace(find,replace,1)
    return string

def get_libtool_major_version():
    """libtool >= 2.1b support lt_dlopenadvise and the previous
    release appears to be 1.9f (based on NEWS) so checking for 
    >= 2 seems adequate.
    """
    cmd = 'libtool'
    if platform.uname()[0] == "Darwin":
        cmd = 'glibtool'
    version = None
    fallback_version = 2
    pattern = r'(.*[^\S])(\d{1}\.\d+\.?\d?)(.*[^\S])'
    ret = os.popen('%s --version' % cmd).read()
    match = re.match(pattern,ret)
    if match:
        groups = match.groups()
        if len(groups):
            version_string = groups[1]
            if version_string:
                version_string = version_string.split('.')[0]
                try:
                    version = int(version_string)
                except ValueError:
                    pass
    if not version:
        color_print(1,'Could not detect libtool --version, assuming major version 2')
        return fallback_version
    return version

# http://www.scons.org/wiki/InstallTargets
def create_uninstall_target(env, path, is_glob=False):
    if 'uninstall' in COMMAND_LINE_TARGETS:
        if is_glob:
            all_files = Glob(path,strings=True)
            for filei in all_files:
                env.Command( "uninstall-"+filei, filei,
                [
                Delete("$SOURCE"),
                ])
                env.Alias("uninstall", "uninstall-"+filei)
        else:
            if os.path.exists(path):
                env.Command( "uninstall-"+path, path,
                [
                Delete("$SOURCE"),
                ])
                env.Alias("uninstall", "uninstall-"+path)
    
def shortest_name(libs):
    name = '-'*200
    for lib in libs:
        if len(name) > len(lib):
            name = lib
    return name


def sort_paths(items,priority):
    """Sort paths such that compiling and linking will globally prefer custom or local libs
    over system libraries by fixing up the order libs are passed to gcc and the linker.
    
    Ideally preference could be by-target instead of global, but our SCons implementation
    is not currently utilizing different SCons build env()'s as we should.
    
    Overally the current approach within these scripts is to prepend paths of preference
    and append all others, but this does not give enough control (particularly due to the
    approach of assuming /usr/LIBSCHEMA and letting paths be parsed and added by pkg-config).
    
    In effect /usr/lib is likely to come before /usr/local/lib which makes linking against
    custom built icu or boost impossible when those libraries are available in both places.
    
    Sorting using a priority list allows this to be controlled, and fine tuned.
    """
    
    new = []
    path_types = {'internal':[],'other':[],'frameworks':[],'user':[],'system':[]}
    # parse types of paths into logical/meaningful groups
    # based on commonly encountered lib directories on linux and osx
    for i in items:
        # internal paths for code kept inside
        # the mapnik sources
        if i.startswith('#'):
            path_types['internal'].append(i)
        # Mac OS X user installed frameworks
        elif '/Library/Frameworks' in i:
            path_types['frameworks'].append(i)
        # various 'local' installs like /usr/local or /opt/local
        elif 'local' in i or '/sw' in i:
            if '/usr/local' in i:
                path_types['user'].insert(0,i)
            else:
                path_types['user'].append(i)
        # key system libs (likely others will fall into 'other')
        elif '/usr/' in i or '/System' in i or '/lib' in i:
            path_types['system'].append(i)
        # anything not yet matched...
        # likely a combo of rare system lib paths and
        # very custom user paths that should ideally be
        # in 'user'
        else:
            path_types['other'].append(i)
    # build up new list based on priority list
    for path in priority:
        if path_types.has_key(path):
            dirs = path_types[path]
            new.extend(dirs)
            path_types.pop(path)
        else:
            color_print(1,'\nSorry, "%s" is NOT a valid value for option "LINK_PRIORITY": values include: %s' % (path,','.join(path_types.keys())))
            color_print(1,'\tinternal: the local directory of the Mapnik sources (prefix #) (eg. used to link internal agg)')
            color_print(1,'\tframeworks: on osx the /Library/Frameworks directory')
            color_print(1,'\tuser: any path with "local" or "/sw" inside it')
            color_print(1,'\tsystem: any path not yet matched with "/usr/","/lib", or "/System" (osx) inside it')

=== debian/changelog ===
mapnik (2.0.0+ds1-3build1) precise; urgency=low

  * Rebuild for libicu48.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 21 Nov 2011 16:10:25 +0000

mapnik (2.0.0+ds1-3) unstable; urgency=low

  * Fix wrong linkage against boost_python-py2*

 -- David Paleino <dapal@debian.org>  Tue, 25 Oct 2011 22:20:35 +0200

mapnik (2.0.0+ds1-2) unstable; urgency=low

  * 03-fix_big-endian.patch added: the variable for big-endian
    architectures was wrongly named (Closes: #644704)

 -- David Paleino <dapal@debian.org>  Sat, 08 Oct 2011 22:14:59 +0200

mapnik (2.0.0+ds1-1) unstable; urgency=low

  * New upstream version
  * Debhelper compatibility bumped to 8
  * New input plugins compiled: geos, rasterlite
  * Package switch from pysupport to dh_python2
  * Package renamed from libmapnik0.7 to libmapnik2-2.0
  * Purge debian/copyright from non-(anymore)-existing files

 -- David Paleino <dapal@debian.org>  Wed, 05 Oct 2011 13:02:49 +0200

=== debian/control ===
Source: mapnik
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Debian OpenStreetMap Team <pkg-osm-maint@lists.alioth.debian.org>
 , David Paleino <dapal@debian.org>
 , Francesco Paolo Lovergine <frankie@debian.org>
Build-Depends:
 scons
 , debhelper (>= 8~)
 , libtool
 , python-all-dev (>= 2.6.6-3~)
 , libboost-thread-dev
 , libboost-filesystem-dev
 , libboost-regex-dev
 , libboost-python-dev
 , libboost-system-dev
 , libboost-program-options-dev
 , libpng12-dev
 , libjpeg-dev
 , libtiff4-dev
 , zlib1g-dev
 , libfreetype6-dev
 , libpq-dev
 , libproj-dev
 , libltdl-dev
 , libgdal1-dev
 , libxml2-dev
 , libicu-dev
 , libcairo2-dev
 , libcairomm-1.0-dev
 , python-cairo-dev
 , libsqlite3-dev
 , libcurl4-gnutls-dev
 , python-epydoc
 , librasterlite-dev (>= 1.1~)
 , libgeos-dev
 , pkg-config
Standards-Version: 3.9.2
Section: libs
X-Python-Version: >= 2.5
Homepage: http://www.mapnik.org/
Vcs-Git: git://git.debian.org/pkg-grass/mapnik.git
Vcs-Browser: http://git.debian.org/?p=pkg-grass/mapnik.git

Package: libmapnik2-2.0
Architecture: any
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
 , ttf-dejavu
Suggests: postgis
Description: C++/Python toolkit for developing GIS applications (libraries)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains the shared library and input plugins.

Package: libmapnik-dev
Section: oldlibs
Architecture: all
Depends:
 libmapnik2-dev
 , ${misc:Depends}
Description: C++/Python toolkit for developing GIS applications (dummy)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package is a transitional package, and can be safely removed if
 nobody depends on it.

Package: libmapnik2-dev
Section: libdevel
Architecture: any
Breaks: libmapnik-dev (<< 2.0.0+ds1-1~)
Replaces: libmapnik-dev (<< 2.0.0+ds1-1~)
Depends:
 ${misc:Depends}
 , libmapnik2-2.0 (= ${binary:Version})
 , libc6-dev | libc-dev
 , libboost-thread-dev
 , libboost-filesystem-dev
 , libboost-regex-dev
 , libboost-python-dev
 , libboost-system-dev
 , libboost-iostreams-dev
 , libpng12-dev
 , libjpeg-dev
 , libtiff4-dev
 , zlib1g-dev
 , libfreetype6-dev
 , libpq-dev
 , libproj-dev
 , libltdl-dev
 , libfribidi-dev
 , libgdal1-dev
 , libxml2-dev
 , libagg-dev
 , libicu-dev
 , libcairo2-dev
 , libcairomm-1.0-dev
 , python-cairo-dev
 , libsqlite3-dev
 , libcurl4-gnutls-dev
 , libsigc++-2.0-dev
Recommends: mapnik-doc
Description: C++/Python toolkit for developing GIS applications (devel)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains the development headers, API documentation, and
 build utilities.

Package: mapnik-utils
Section: utils
Architecture: any
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
 , ${python:Depends}
 , python-mapnik2
 , python-lxml
Description: C++/Python toolkit for developing GIS applications (utilities)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains miscellaneous utilities distributed with mapnik:
 .
 shapeindex: program to creates file system based index for ESRI shape-files

Package: python-mapnik2
Section: python
Architecture: any
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
 , ${python:Depends}
 , python-cairo
Provides: ${python:Provides}
Description: C++/Python toolkit for developing GIS applications (Python)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains the Python bindings.

Package: mapnik-doc
Section: doc
Architecture: all
Recommends: libmapnik2-dev
Depends: ${misc:Depends}
Description: C++/Python toolkit for developing GIS applications (doc)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains developer documentation.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds\d// \
http://download.berlios.de/mapnik/mapnik-(\d+.*)\.tar\.gz

## mapnik 2.2.0%2Bds1

=== debian/changelog ===
mapnik (2.2.0+ds1-7~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Pierre Rudloff <contact@rudloff.pro>  Fri, 09 May 2014 00:12:38 +0200

mapnik (2.2.0+ds1-7) unstable; urgency=medium

  * Standards-Version 3.9.5
  * Set priority of python-mapnik2, libmapnik2-dev to oldlibs/extra.
  * Add 1002 upstream patch to reduce memory usage during compilation
    using BOOST_SPIRIT_NO_PREDEFINED_TERMINALS (#742149).
  * Disable debugging symbols to save memory during compilation.
    This and the previous change should be enough to close: #742149.
  * Build multiple python versions using scons properly, so that scons
    doesn't build everything twice.
  * Copyright:
    + use Files-Excluded, now repackaging is done by uscan
    + add section for debian/rules technique taken from fife package
  * Watch github directly, no need for githubredir.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 06 Apr 2014 15:35:41 +0200

mapnik (2.2.0+ds1-6) unstable; urgency=medium

  * Team upload.
  * Changed libgdal1-dev in libgdal-dev.
  * Priority set to optional for all packages.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 11 Dec 2013 18:12:19 +0100

mapnik (2.2.0+ds1-5) unstable; urgency=low

  * Set gcc optimization flag to -O2 instead of -O3.
  * Add 2001 patch to remove gcc -ftemplate-depth-300 flag.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 12 Oct 2013 16:24:50 +0200

mapnik (2.2.0+ds1-4) unstable; urgency=low

  * Disable completely parallel builds. It might be responsible
    for memory exhaustion on s390, mipsel, mips.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 03 Oct 2013 14:24:42 +0200

mapnik (2.2.0+ds1-3) unstable; urgency=low

  * Honour DEB_BUILD_OPTIONS parallel, defaults to 1.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 02 Oct 2013 21:55:37 +0200

mapnik (2.2.0+ds1-2) unstable; urgency=low

  * Build documentation in -indep target. (Closes: #721579)

 -- Jérémy Lal <kapouer@melix.org>  Sun, 08 Sep 2013 13:34:41 +0200

mapnik (2.2.0+ds1-1) unstable; urgency=low

  [ Andrew Harvey ]
  * Change debian/rules to use top level font directory (Closes: #665798)

  [ David Paleino ]
  * New upstream version 2.1
    - fixed compatibility with PostGIS 2.0 (AsBinary() → ST_AsBinary())
      (Closes: #699079)
  * Switch debian/watch to github tags
  * debian/patches/:
    - 02-fix_FTBFS_binutils-gold.patch refreshed
    - 03-fix_ImportError_mips.patc, 03-fix_big-endian.patch and
      04-port_to_new_boost.patch removed
  * Python bindings testsuite temporarily disabled
  * Adapt debian/rules get-orig-source target to new upstream layout
  * Build-Depends on libpng-dev instead of libpng12-dev (Closes: #662425)
  * Bump debhelper compatibility to 9
  * Bump Standards-Version to 3.9.4, no changes needed

  [ Jérémy Lal ]
  * New upstream version 2.2
  * control:
    + Transition libmapnik2 to libmapnik (#674587)
    + Transition python-mapnik2 to python-mapnik
    + Canonicalize Vcs fields
  * copyright:
    + entire tarball review
    + switch to copyright 1.0 format
    + DFSG-exclude tests/data/fonts/XB\ Zar.ttf (missing license)
    + conveniently exclude scons, fonts, and some test files for the
      sake of copyright simplification.
  * rules:
    + update input plugins list, remove geos, kismet and add csv,
      geojson, python.
    + disable building demo
    + remove unneeded workarounds in some targets
    + call epydoc directly instead of fiddling with build script
    + pass hardening build flags to mapnik SConstruct,
      thanks to YunQiang Su.
  * patch: 1001 patch to link mapnik lib to dl.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 27 Aug 2013 10:16:08 +0200

## mapnik 2.2.0+ds1

=== Makefile ===
UNAME := $(shell uname)
LINK_FIX=LD_LIBRARY_PATH
ifeq ($(UNAME), Darwin)
	LINK_FIX=DYLD_LIBRARY_PATH
else
endif

OS:=$(shell uname -s)

ifeq ($(JOBS),)
	JOBS:=1
	ifeq ($(OS),Linux)
		JOBS:=$(shell grep -c ^processor /proc/cpuinfo)
	endif
	ifeq ($(OS),Darwin)
		JOBS:=$(shell sysctl -n hw.ncpu)
	endif
endif

all: mapnik

install:
	@python scons/scons.py -j$(JOBS) --config=cache --implicit-cache --max-drift=1 install

mapnik:
	@python scons/scons.py -j$(JOBS) --config=cache --implicit-cache --max-drift=1

clean:
	@python scons/scons.py -j$(JOBS) -c --config=cache --implicit-cache --max-drift=1
	@if test -e ".sconsign.dblite"; then rm ".sconsign.dblite"; fi
	@if test -e "config.log"; then rm  "config.log"; fi
	@if test -e ".sconf_temp/"; then rm -r ".sconf_temp/"; fi
	@find ./ -name "*.pyc" -exec rm {} \;
	@find ./ -name "*.os" -exec rm {} \;
	@find ./ -name "*.o" -exec rm {} \;
	@find ./ -name "*.pyc" -exec rm {} \;
	@if test -e "bindings/python/mapnik/paths.py"; then rm "bindings/python/mapnik/paths.py"; fi

distclean:
	@if test -e "config.cache"; then rm "config.cache"; fi
	if test -e "config.py"; then mv "config.py" "config.py.backup"; fi

reset: distclean

rebuild:
	make uninstall && make clean && time make && make install

uninstall:
	@python scons/scons.py -j$(JOBS) --config=cache --implicit-cache --max-drift=1 uninstall

test:
	@ ./run_tests

test-local:
	@echo "*** Boostrapping local test environment..."
	@export ${LINK_FIX}=`pwd`/src:${${LINK_FIX}} && \
	export PATH=`pwd`/utils/mapnik-config/:${PATH} && \
	export PYTHONPATH=`pwd`/bindings/python/:${PYTHONPATH} && \
	export MAPNIK_FONT_DIRECTORY=`pwd`/fonts/dejavu-fonts-ttf-2.33/ttf/ && \
	export MAPNIK_INPUT_PLUGINS_DIRECTORY=`pwd`/plugins/input/ && \
	make test

bench:
	@export ${LINK_FIX}=`pwd`/src:${${LINK_FIX}} && \
	./benchmark/run

check: test-local

demo:
	@echo "*** Running rundemo.cpp…"
	cd demo/c++; ./rundemo `mapnik-config --prefix`

pep8:
	# https://gist.github.com/1903033
	# gsed on osx
	@pep8 -r --select=W293 -q --filename=*.py `pwd`/tests/ | xargs gsed -i 's/^[ \r\t]*$//'
	@pep8 -r --select=W391 -q --filename=*.py `pwd`/tests/ | xargs gsed -i -e :a -e '/^\n*$/{$d;N;ba' -e '}'

grind:
	@for FILE in tests/cpp_tests/*-bin; do \
		valgrind --leak-check=full --log-fd=1 $${FILE} | grep definitely; \
	done

render:
	@for FILE in tests/data/good_maps/*xml; do \
		nik2img.py $${FILE} /tmp/$$(basename $${FILE}).png; \
	done

.PHONY: install mapnik clean distclean reset uninstall test demo pep8 grind render

=== SConstruct ===
# This file is part of Mapnik (c++ mapping toolkit)
#
# Copyright (C) 2009 Artem Pavlenko, Jean-Francois Doyon, Dane Springmeyer
#
# Mapnik is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import os
import sys
import re
import platform
from glob import glob
from copy import copy
from subprocess import Popen, PIPE
from SCons.SConf import SetCacheMode
import pickle

try:
    import distutils.sysconfig
    HAS_DISTUTILS = True
except:
    HAS_DISTUTILS = False

LIBDIR_SCHEMA_DEFAULT='lib'
severities = ['debug', 'warn', 'error', 'none']

DEFAULT_CC = "gcc"
DEFAULT_CXX = "g++"
if sys.platform == 'darwin':
    DEFAULT_CC = "clang"
    DEFAULT_CXX = "clang++"

py3 = None

# local file to hold custom user configuration variables
# Todo check timestamp, reload if changed?
SCONS_LOCAL_CONFIG = 'config.py'
# build log
SCONS_LOCAL_LOG = 'config.log'
# local pickled file to cache configured environment
SCONS_CONFIGURE_CACHE = 'config.cache'
# directory SCons uses to stash build tests
SCONF_TEMP_DIR = '.sconf_temp'
# auto-search directories for boost libs/headers
BOOST_SEARCH_PREFIXES = ['/usr/local','/opt/local','/sw','/usr',]
BOOST_MIN_VERSION = '1.47'
#CAIRO_MIN_VERSION = '1.8.0'

DEFAULT_LINK_PRIORITY = ['internal','other','frameworks','user','system']


pretty_dep_names = {
    'ociei':'Oracle database library | configure with OCCI_LIBS & OCCI_INCLUDES | more info: https://github.com/mapnik/mapnik/wiki/OCCI',
    'gdal':'GDAL C++ library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: https://github.com/mapnik/mapnik/wiki/GDAL',
    'ogr':'OGR-enabled GDAL C++ Library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: https://github.com/mapnik/mapnik/wiki/OGR',
    'cairo':'Cairo C library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'pycairo':'Python bindings to Cairo library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'proj':'Proj.4 C Projections library | configure with PROJ_LIBS & PROJ_INCLUDES | more info: http://trac.osgeo.org/proj/',
    'pg':'Postgres C Library required for PostGIS plugin | configure with pg_config program | more info: https://github.com/mapnik/mapnik/wiki/PostGIS',
    'sqlite3':'SQLite3 C Library | configure with SQLITE_LIBS & SQLITE_INCLUDES | more info: https://github.com/mapnik/mapnik/wiki/SQLite',
    'jpeg':'JPEG C library | configure with JPEG_LIBS & JPEG_INCLUDES',
    'tiff':'TIFF C library | configure with TIFF_LIBS & TIFF_INCLUDES',
    'png':'PNG C library | configure with PNG_LIBS & PNG_INCLUDES',
    'icuuc':'ICU C++ library | configure with ICU_LIBS & ICU_INCLUDES or use ICU_LIB_NAME to specify custom lib name  | more info: http://site.icu-project.org/',
    'z':'Z compression library | more info: http://www.zlib.net/',
    'm':'Basic math library, part of C++ stlib',
    'pkg-config':'pkg-config tool | more info: http://pkg-config.freedesktop.org',
    'pg_config':'pg_config program | try setting PG_CONFIG SCons option',
    'xml2-config':'xml2-config program | try setting XML2_CONFIG SCons option',
    'libxml2':'libxml2 library | try setting XML2_CONFIG SCons option to point to location of xml2-config program',
    'gdal-config':'gdal-config program | try setting GDAL_CONFIG SCons option',
    'freetype-config':'freetype-config program | try setting FREETYPE_CONFIG SCons option',
    'osm':'more info: https://github.com/mapnik/mapnik/wiki/OsmPlugin',
    'curl':'libcurl is required for the "osm" plugin - more info: https://github.com/mapnik/mapnik/wiki/OsmPlugin',
    'boost_regex_icu':'libboost_regex built with optional ICU unicode support is needed for unicode regex support in mapnik.',
    'sqlite_rtree':'The SQLite plugin requires libsqlite3 built with RTREE support (-DSQLITE_ENABLE_RTREE=1)',
    'pgsql2sqlite_rtree':'The pgsql2sqlite program requires libsqlite3 built with RTREE support (-DSQLITE_ENABLE_RTREE=1)'
    }

# Core plugin build configuration
# opts.AddVariables still hardcoded however...
PLUGINS = { # plugins with external dependencies
            # configured by calling project, hence 'path':None
            'postgis': {'default':True,'path':None,'inc':'libpq-fe.h','lib':'pq','lang':'C'},
            'gdal':    {'default':True,'path':None,'inc':'gdal_priv.h','lib':'gdal','lang':'C++'},
            'ogr':     {'default':True,'path':None,'inc':'ogrsf_frmts.h','lib':'gdal','lang':'C++'},
            # configured with custom paths, hence 'path': PREFIX/INCLUDES/LIBS
            'occi':    {'default':False,'path':'OCCI','inc':'occi.h','lib':'ociei','lang':'C++'},
            'sqlite':  {'default':True,'path':'SQLITE','inc':'sqlite3.h','lib':'sqlite3','lang':'C'},
            'rasterlite':  {'default':False,'path':'RASTERLITE','inc':['sqlite3.h','rasterlite.h'],'lib':'rasterlite','lang':'C'},

            # todo: osm plugin does also depend on libxml2 (but there is a separate check for that)
            'osm':     {'default':False,'path':None,'inc':'curl/curl.h','lib':'curl','lang':'C'},

            # plugins without external dependencies requiring CheckLibWithHeader...
            'shape':   {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'csv':     {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'raster':  {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'geojson': {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'python':  {'default':False,'path':None,'inc':None,'lib':None,'lang':'C++'},
            }


#### SCons build options and initial setup ####
env = Environment(ENV=os.environ)
env.Decider('MD5-timestamp')
env.SourceCode(".", None)

def color_print(color,text,newline=True):
    # 1 - red
    # 2 - green
    # 3 - yellow
    # 4 - blue
    text = "\033[9%sm%s\033[0m" % (color,text)
    if not newline:
        print text,
    else:
        print text

def regular_print(color,text,newline=True):
    if not newline:
        print text,
    else:
        print text

def call(cmd, silent=False):
    stdin, stderr = Popen(cmd, shell=True, stdout=PIPE, stderr=PIPE).communicate()
    if not stderr:
        return stdin.strip()
    elif not silent:
        color_print(1,'Problem encounted with SCons scripts, please post bug report to: https://github.com/mapnik/mapnik/issues \nError was: %s' % stderr)

def strip_first(string,find,replace=''):
    if string.startswith(find):
        return string.replace(find,replace,1)
    return string

# http://www.scons.org/wiki/InstallTargets
def create_uninstall_target(env, path, is_glob=False):
    if 'uninstall' in COMMAND_LINE_TARGETS:
        if is_glob:
            all_files = Glob(path,strings=True)
            for filei in all_files:
                env.Command( "uninstall-"+filei, filei,
                [
                Delete("$SOURCE"),
                ])
                env.Alias("uninstall", "uninstall-"+filei)
        else:
            if os.path.exists(path):
                env.Command( "uninstall-"+path, path,
                [
                Delete("$SOURCE"),
                ])
                env.Alias("uninstall", "uninstall-"+path)

def shortest_name(libs):
    name = '-'*200
    for lib in libs:
        if len(name) > len(lib):
            name = lib
    return name

def rm_path(item,set,_env):
    for i in _env[set]:
        if item in i:
            _env[set].remove(i)

def sort_paths(items,priority):
    """Sort paths such that compiling and linking will globally prefer custom or local libs
    over system libraries by fixing up the order libs are passed to the compiler and the linker.

    Ideally preference could be by-target instead of global, but our SCons implementation
    is not currently utilizing different SCons build env()'s as we should.

    Overally the current approach within these scripts is to prepend paths of preference
    and append all others, but this does not give enough control (particularly due to the
    approach of assuming /usr/LIBSCHEMA and letting paths be parsed and added by pkg-config).

    In effect /usr/lib is likely to come before /usr/local/lib which makes linking against
    custom built icu or boost impossible when those libraries are available in both places.

    Sorting using a priority list allows this to be controlled, and fine tuned.
    """

    new = []
    path_types = {'internal':[],'other':[],'frameworks':[],'user':[],'system':[]}
    # parse types of paths into logical/meaningful groups
    # based on commonly encountered lib directories on linux and osx
    for i in items:
        # internal paths for code kept inside
        # the mapnik sources
        if i.startswith('#'):
            path_types['internal'].append(i)
        # Mac OS X user installed frameworks
        elif '/Library/Frameworks' in i:
            path_types['frameworks'].append(i)
        # various 'local' installs like /usr/local or /opt/local
        elif 'local' in i or '/sw' in i:
            if '/usr/local' in i:
                path_types['user'].insert(0,i)
            else:
                path_types['user'].append(i)
        # key system libs (likely others will fall into 'other')
        elif '/usr/' in i or '/System' in i or i.startswith('/lib'):
            path_types['system'].append(i)
        # anything not yet matched...
        # likely a combo of rare system lib paths and
        # very custom user paths that should ideally be
        # in 'user'
        else:
            path_types['other'].append(i)
    # build up new list based on priority list
    for path in priority:
        if path_types.has_key(path):
            dirs = path_types[path]
            new.extend(dirs)
            path_types.pop(path)
        else:
            color_print(1,'\nSorry, "%s" is NOT a valid value for option "LINK_PRIORITY": values include: %s' % (path,','.join(path_types.keys())))
            color_print(1,'\tinternal: the local directory of the Mapnik sources (prefix #) (eg. used to link internal agg)')
            color_print(1,'\tframeworks: on osx the /Library/Frameworks directory')
            color_print(1,'\tuser: any path with "local" or "/sw" inside it')
            color_print(1,'\tsystem: any path not yet matched with "/usr/","/lib", or "/System" (osx) inside it')
            color_print(1,'\tother: any paths you specified not matched by criteria used to parse the others')
            color_print(1,'\tother: any paths you specified not matched by criteria used to parse the others')
            color_print(1,'The Default priority is: %s' % ','.join(DEFAULT_LINK_PRIORITY))
            color_print(1,'Any priority groups not listed will be appended to the list at the end')
            Exit(1)
    # append remaining paths potentially not requested
    # by any custom priority list defined by user
    for k,v in path_types.items():
        new.extend(v)
    return new

def pretty_dep(dep):
    pretty = pretty_dep_names.get(dep)
    if pretty:
        return '%s (%s)' % (dep,pretty)
    elif 'boost' in dep:
        return '%s (%s)' % (dep,'more info see: https://github.com/mapnik/mapnik/wiki/Mapnik-Installation & http://www.boost.org')
    return dep


DEFAULT_PLUGINS = []
for k,v in PLUGINS.items():
   if v['default']:

=== debian/control ===
--- 
+++ 
@@ -4,45 +4,43 @@
 Uploaders: Debian OpenStreetMap Team <pkg-osm-maint@lists.alioth.debian.org>
  , David Paleino <dapal@debian.org>
  , Francesco Paolo Lovergine <frankie@debian.org>
+ , Jérémy Lal <kapouer@melix.org>
 Build-Depends:
  scons
- , debhelper (>= 8~)
+ , debhelper (>= 9~)
  , libtool
  , python-all-dev (>= 2.6.6-3~)
+ , libboost-filesystem-dev
+ , libboost-system-dev
  , libboost-thread-dev
- , libboost-filesystem-dev
  , libboost-regex-dev
- , libboost-python-dev
- , libboost-system-dev
  , libboost-program-options-dev
- , libpng12-dev
+ , libicu-dev
+ , libpng-dev
  , libjpeg-dev
- , libtiff4-dev
+ , libtiff-dev
  , zlib1g-dev
  , libfreetype6-dev
+ , libxml2-dev
+ , libproj-dev
+ , libboost-python-dev
+ , libcairo2-dev
+ , pkg-config
+ , python-cairo-dev
  , libpq-dev
- , libproj-dev
- , libltdl-dev
- , libgdal1-dev
- , libxml2-dev
- , libicu-dev
- , libcairo2-dev
- , libcairomm-1.0-dev
- , python-cairo-dev
+ , libgdal-dev
  , libsqlite3-dev
  , libcurl4-gnutls-dev
+ , librasterlite-dev
  , python-epydoc
- , librasterlite-dev (>= 1.1~)
- , libgeos-dev
- , pkg-config
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Section: libs
 X-Python-Version: >= 2.5
 Homepage: http://www.mapnik.org/
-Vcs-Git: git://git.debian.org/pkg-grass/mapnik.git
-Vcs-Browser: http://git.debian.org/?p=pkg-grass/mapnik.git
-
-Package: libmapnik2-2.0
+Vcs-Git: git://anonscm.debian.org/pkg-grass/mapnik.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/mapnik.git
+
+Package: libmapnik2.2
 Architecture: any
 Depends:
  ${shlibs:Depends}
@@ -64,11 +62,12 @@
  .
  This package contains the shared library and input plugins.
 
-Package: libmapnik-dev
+Package: libmapnik2-dev
+Priority: extra
 Section: oldlibs
 Architecture: all
 Depends:
- libmapnik2-dev
+ libmapnik-dev
  , ${misc:Depends}
 Description: C++/Python toolkit for developing GIS applications (dummy)
  Mapnik is an OpenSource C++/Python toolkit for developing GIS
@@ -86,40 +85,37 @@
  This package is a transitional package, and can be safely removed if
  nobody depends on it.
 
-Package: libmapnik2-dev
+Package: libmapnik-dev
 Section: libdevel
 Architecture: any
-Breaks: libmapnik-dev (<< 2.0.0+ds1-1~)
-Replaces: libmapnik-dev (<< 2.0.0+ds1-1~)
+Breaks: libmapnik2-dev (<< 2.2.0+ds1-1~)
+Replaces: libmapnik2-dev (<< 2.2.0+ds1-1~)
 Depends:
  ${misc:Depends}
- , libmapnik2-2.0 (= ${binary:Version})
+ , libmapnik2.2 (= ${binary:Version})
  , libc6-dev | libc-dev
+ , libboost-filesystem-dev
+ , libboost-system-dev
  , libboost-thread-dev
- , libboost-filesystem-dev
  , libboost-regex-dev
- , libboost-python-dev
- , libboost-system-dev
- , libboost-iostreams-dev
- , libpng12-dev
+ , libboost-program-options-dev
+ , libicu-dev
+ , libpng-dev
  , libjpeg-dev
- , libtiff4-dev
+ , libtiff-dev
  , zlib1g-dev
  , libfreetype6-dev
+ , libxml2-dev
+ , libproj-dev
+ , libboost-python-dev
+ , libcairo2-dev
+ , pkg-config
+ , python-cairo-dev
  , libpq-dev
- , libproj-dev
- , libltdl-dev
- , libfribidi-dev
  , libgdal1-dev
- , libxml2-dev
- , libagg-dev
- , libicu-dev
- , libcairo2-dev
- , libcairomm-1.0-dev
- , python-cairo-dev
  , libsqlite3-dev
  , libcurl4-gnutls-dev
- , libsigc++-2.0-dev
+ , librasterlite-dev
 Recommends: mapnik-doc
 Description: C++/Python toolkit for developing GIS applications (devel)
  Mapnik is an OpenSource C++/Python toolkit for developing GIS
@@ -144,7 +140,7 @@
  ${shlibs:Depends}
  , ${misc:Depends}
  , ${python:Depends}
- , python-mapnik2
+ , python-mapnik
  , python-lxml
 Description: C++/Python toolkit for developing GIS applications (utilities)
  Mapnik is an OpenSource C++/Python toolkit for developing GIS
@@ -163,7 +159,7 @@
  .
  shapeindex: program to creates file system based index for ESRI shape-files
 
-Package: python-mapnik2
+Package: python-mapnik
 Section: python
 Architecture: any
 Depends:
@@ -171,6 +167,8 @@
  , ${misc:Depends}
  , ${python:Depends}
  , python-cairo
+Breaks: python-mapnik2 (<< 2.2.0+ds1-1~)
+Replaces: python-mapnik2 (<< 2.2.0+ds1-1~)
 Provides: ${python:Provides}
 Description: C++/Python toolkit for developing GIS applications (Python)
  Mapnik is an OpenSource C++/Python toolkit for developing GIS
@@ -186,11 +184,34 @@
  development, targeting zope3, django, etc.
  .
  This package contains the Python bindings.
+
+Package: python-mapnik2
+Priority: extra
+Section: oldlibs
+Architecture: all
+Depends:
+ ${misc:Depends}
+ , python-mapnik
+Description: C++/Python toolkit for developing GIS applications (dummy)
+ Mapnik is an OpenSource C++/Python toolkit for developing GIS
+ (Geographic Information Systems) applications. At the core is a C++
+ shared library providing algorithms/patterns for spatial data access and
+ visualization.
+ .
+ Essentially a collection of geographic objects (map, layer, datasource,
+ feature, geometry), the library doesn't rely on "windowing systems" and
+ is intended to work in multi-threaded environments
+ .
+ High-level Python bindings (boost.python) facilitate rapid application
+ development, targeting zope3, django, etc.
+ .
+ This package is a transitional package, and can be safely removed if
+ nobody depends on it.
 
 Package: mapnik-doc
 Section: doc
 Architecture: all
-Recommends: libmapnik2-dev
+Recommends: libmapnik-dev
 Depends: ${misc:Depends}
 Description: C++/Python toolkit for developing GIS applications (doc)
  Mapnik is an OpenSource C++/Python toolkit for developing GIS

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# scons flags
# Disable parallel build - it exhausts memory on s390, mipsel, mips
SCONS = $(shell which scons)
SCONS_FLAGS := -j1
# -O2
SCONS_FLAGS += OPTIMIZATION=2
SCONS_FLAGS += INPUT_PLUGINS=csv,gdal,geojson,ogr,osm,postgis,python,raster,rasterlite,shape,sqlite
SCONS_FLAGS += PROJ_INCLUDES=/usr/include PROJ_LIBS=/usr/lib
SCONS_FLAGS += SYSTEM_FONTS=/usr/share/fonts
SCONS_FLAGS += XMLPARSER=libxml2
SCONS_FLAGS += DEMO=False
SCONS_FLAGS += CPP_TESTS=False
SCONS_FLAGS += PREFIX=/usr LIB_DIR_NAME=/mapnik/2.2
SCONS_FLAGS += CUSTOM_CXXFLAGS="$(shell dpkg-buildflags --get CXXFLAGS) -g0"
SCONS_FLAGS += CUSTOM_CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -g0"
SCONS_FLAGS += CUSTOM_LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) -g0"
SCONS_FLAGS += CUSTOM_DEFINES="$(shell dpkg-buildflags --get CPPFLAGS) -g0"

PYVERS = $(shell pyversions -r -v)

override_dh_auto_configure: $(PYVERS:%=debian/stamps/configure-python%)
debian/stamps/configure-python%:
	-mkdir build-python$*
	-mkdir debian/stamps
	cp -r bindings boost demo deps fonts include plugins src tests utils workspace SConstruct build-python$*
	touch $@
	python$* $(SCONS) -C build-python$* configure \
		$(SCONS_FLAGS) \
		CCFLAGS="$(CFLAGS)" \
		BOOST_PYTHON_LIB=boost_python-py$$(echo $* | sed 's@\.@@') \
		DESTDIR=$(CURDIR)/debian/tmp

override_dh_auto_build:	$(PYVERS:%=debian/stamps/build-python%)
debian/stamps/build-python%:
	python$* $(SCONS) -C build-python$*

override_dh_prep:
	dh_prep -Xdebian/tmp

override_dh_auto_install:	$(PYVERS:%=debian/stamps/install-python%)
debian/stamps/install-python%:
	python$* $(SCONS) -C build-python$* install

override_dh_install-arch:
	dh_install
	mv $(CURDIR)/debian/mapnik-utils/usr/bin/upgrade_map_xml.py \
		$(CURDIR)/debian/mapnik-utils/usr/bin/upgrade-map-xml

override_dh_install-indep:
	# build Python API documentation
	# and trick epydoc into loading the shlib too
	LD_LIBRARY_PATH=$(CURDIR)/debian/libmapnik2.2/usr/lib/ epydoc --no-private \
		--no-frames \
		--no-sourcecode \
		--name mapnik \
		--url http://mapnik.org \
		--css $(CURDIR)/utils/epydoc_config/mapnik_epydoc.css \
		$(CURDIR)/bindings/python/mapnik \
		-o $(CURDIR)/debian/mapnik-doc/usr/share/doc/mapnik-doc/python

override_dh_auto_clean:
	rm -rf build-python*
	rm -rf debian/stamps
	dh_clean

override_dh_auto_test:	$(PYVERS:%=debian/stamps/test-python%)
debian/stamps/test-python%:
	# nothing yet

%:
	dh $@ --with python2

=== debian/watch ===
version=3
opts=filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/mapnik-$1.tar.gz/,dversionmangle=s/\+ds[\d]*$// \
https://github.com/mapnik/mapnik/tags .*/archive/v?([\d\.]+).tar.gz
